
# 将不同时间的add 的hold信息合并在一起 分析他们的变化 找出庄家地址/分析庄家变化 
import pandas as pd
import sys

import datetime
import pytz
from openpyxl.styles import *
# from openpyxl.styles.colors import RED, GREEN
arr_file = []
merged_df = None
 
token_add = ""


def makeurl( url,url_show):
    return '=HYPERLINK("{}","{}")'.format(url,  url_show)




def get_nowdate():

    timestamp = datetime.datetime.now().timestamp()
    # print(timestamp)
    dt = datetime.datetime.fromtimestamp(timestamp)
    tz = pytz.timezone('Asia/Shanghai')
    normal_time_str = dt.astimezone(tz).strftime('%Y-%m-%d %H:%M:%S')
    time_str = dt.astimezone(tz).strftime('%m%d%H%M')
    return time_str

 
 
arr_df = []

merged_hodlers_file = ""
merged_special_ad_hold_info_file=""
def merge_swap_df_fun_02():
    global merged_hodlers_file , merged_special_ad_hold_info_file
    global arr_df
    merged_hodlers_excel = pd.ExcelFile(merged_hodlers_file)
    arr_sheet_names = list(merged_hodlers_excel.sheet_names)
    arr_sheet_names.pop(0)

    merged_df= pd.read_excel('special_add_hold_info.xlsx',engine='openpyxl')
    merged_df["gmgn"] = merged_df.apply(lambda ser: makeurl(
    f"https://gmgn.ai/sol/token/{token_add}?tab=activity&maker={ser['holder_owner']}" , "gmgn" ), axis=1)
    merged_df["defined"] = merged_df.apply(lambda ser: makeurl(
     f"https://www.defined.fi/sol/{token_add}?maker={ser['holder_owner']}" , "defined" ), axis=1)
    
  
    
    arr_df.append(merged_df)
    
    for sheet_name in arr_sheet_names:
        holder_df = merged_hodlers_excel.parse(sheet_name=sheet_name)

        cur_df = merged_df[  merged_df['holder_owner'].isin(holder_df['holder_owner'])].reset_index(drop=True)
        cur_df = cur_df.set_index('holder_owner').reindex(holder_df['holder_owner']).reset_index()

        arr_df.append(cur_df)   


    time_str = get_nowdate()


    with pd.ExcelWriter(f'merge_special_add_holders_{time_str}.xlsx') as writer:
        for idx ,cur_df in enumerate(arr_df):
            sheet_name = ''

            if idx==0:
                sheet_name = 'Sheet1'
            else:
                sheet_name = arr_sheet_names[idx-1]
            cur_df.to_excel(writer, sheet_name=sheet_name, index=False)
   
 
  


def makeurl( url,url_show):
    return '=HYPERLINK("{}","{}")'.format(url,  url_show)

if __name__ == "__main__":
    if len(sys.argv)<3:
        print("args queshao ")
        sys.exit(1)
    token_add = sys.argv[1]
    merged_hodlers_file = sys.argv[2]
    merged_special_ad_hold_info_file = sys.argv[3]
    merge_swap_df_fun_02()
