

import pandas as pd
from datetime import datetime
import pytz

# 示例数据
data = {'time_str': ['2025-01-07 14:39']}
df = pd.DataFrame(data)


def utc_2_shanghaidate(df , utc_time_col ):
# 将字符串转换为UTC时间的datetime对象
    df['shanghai_date'] = pd.to_datetime(df[utc_time_col], utc=True)

    # 定义UTC+8时区
    utc_plus_8 = pytz.timezone('Asia/Shanghai')
    # 转换为UTC+8时间
    df['shanghai_date'] = df['shanghai_date'].dt.tz_convert(utc_plus_8)
    # 提取时间字符串
    df['shanghai_date'] = df['shanghai_date'].dt.strftime('%Y-%m-%d %H:%M')

    print(df)

utc_2_shanghaidate(df=df ,utc_time_col= 'time_str' )  

